---
title: CSSStyleSheet.cssRules
slug: Web/API/CSSStyleSheet/cssRules
tags:
  - API
  - CSS
  - CSSOM
  - CSSOM API
  - CSSStyleSheet
  - Layout
  - Object Model
  - Property
  - Read-only
  - Reference
  - StyleSheet
---
<p>{{APIRef("CSSOM")}}</p>

<p><span class="seoSummary">The read-only {{domxref("CSSStyleSheet")}} property <code><strong>cssRules</strong></code> returns a live {{domxref("CSSRuleList")}} which provides a real-time, up-to-date list of every CSS rule which comprises the stylesheet.</span> Each item in the list is a {{domxref("CSSRule")}} defining a single rule.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>rules</em> = <em>cssStyleSheet</em>.cssRules;</pre>

<h3 id="Value">Value</h3>

<p>A live-updating {{domxref("CSSRuleList")}} containing each of the CSS rules making up the stylesheet. Each entry in the rule list is a {{domxref("CSSRule")}} object describing one rule making up the stylesheet.</p>

<h2 id="Examples">Examples</h2>

<p>Individual rules within the stylesheet can then be accessed by index:</p>

<pre class="brush: js">let ruleList = document.styleSheets[0].cssRules;

for (let i=0; i &lt; ruleList.length; i++) {
  processRule(ruleList[i]);
}
</pre>

<p>Rules can also be accessed using {{jsxref("for...of")}}:</p>

<pre class="brush: js">let ruleList = document.styleSheets[0].cssRules;

for (let rule of ruleList) {
  processRule(rule);
}
</pre>

<p>However, because <code>CSSRule</code> is not a proper array, you can't use {{jsxref("Array.forEach", "forEach()")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("CSSOM", "#dom-cssstylesheet-cssrules", 'CSSStyleSheet.cssRules')}}</td>
   <td>{{Spec2("CSSOM")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSStyleSheet.cssRules")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CSS_Object_Model">CSS Object Model</a></li>
 <li><a href="/en-US/docs/Web/API/CSS_Object_Model/Using_dynamic_styling_information">Using dynamic styling information</a></li>
</ul>
